from Tkinter import *
import whrandom
import string
import tkMessageBox

class hangman:
	def __init__( self, master ):
		self.__master = master
		self.__stage = Canvas( master, height = 303, width = 200, bg = "white" )
		self.__stage.grid( row = 0, column = 0, rowspan = 14, columnspan = 2 )
		self.__drawImages()

		self.__btnnewgame = Button( master, text = "New Game", command = self.__newgame )
		self.__btnnewgame.grid( row = 0, column = 2, sticky = "nw", pady = 2 )

		self.__btnquit = Button( master, text = "Quit", command = self.__quit )
		self.__btnquit.grid( row = 0, column = 2, sticky = "ne", pady = 2 )
		
		
		self.__chrbtns = {}
		
		frame1 = Frame( master, bg = "white" )
		frame1.grid( row = 5, column = 2, sticky = "nw" )

		frame2 = Frame( master, bg = "black" )
		frame2.grid( row = 6, column = 2, sticky = "nw" )

		
		for x in range( 65, 78 ):
			self.__chrbtns[ chr(x) ] =  Button( frame1, text = chr(x), width = 2 )
			self.__chrbtns[ chr(x) ].pack( side = "left" )
			self.__chrbtns[ chr(x) ].bind( "<ButtonRelease-1>", self.__btnclick )

		for x in range( 78, 91 ):
			self.__chrbtns[ chr(x) ] =  Button( frame2, text = chr(x), width = 2 )
			self.__chrbtns[ chr(x) ].pack( side = "left" )
			self.__chrbtns[ chr(x) ].bind( "<ButtonRelease-1>", self.__btnclick )

		self.__blanks = Label( self.__master, text = "", font = ("System", 12, "bold") )
		self.__blanks.grid( row = 2, column = 2, sticky = "sw" )			


		self.__newgame()

	def __quit( self ):
		dlg = tkMessageBox.showinfo( title = "The answer!",
						message = "You Lose.\n The answer was "+self.__word+"."
						)
		self.__newgame()

	def __ignore( self, event ):
		pass

	def __btnclick( self, event ):
		
		for x in range( 65, 91 ):
			if self.__chrbtns[ chr(x) ] == event.widget:
				self.__chrEnter( chr(x) )
				break

	def __chrEnter( self, ch ):
		self.__chrbtns[ ch ]["state"] = DISABLED
		self.__chrbtns[ ch ]["relief"] = "sunken"
		self.__chrbtns[ ch ].bind( "<ButtonRelease-1>", self.__ignore )

		ch = string.lower( ch )
		
		count = 0
		if self.__trials < 6:
			ix = string.find( self.__word, ch, 0 )
			while ix >= 0:
				count = count + 1
				self.__blankstr = self.__blankstr[ 0:ix*2 ] + ch + self.__blankstr[ ix*2 +1: ]
				self.__blanks["text"] = self.__blankstr
				ix = string.find( self.__word, ch, ix+1 )
			self.__correct = self.__correct + count
		
			if count <= 0:
				self.__trials = self.__trials + 1
				self.__stage.lower( self.__covers[ self.__trials ] )
				if self.__trials >= 6:
					dlg = tkMessageBox.showinfo( title = "Sorry!",
								message = "You Lose.\n The answer was "+self.__word+"."
								)
					self.__newgame()
			else:
				if self.__correct >= len( self.__word ):
					dlg = tkMessageBox.showinfo( title = "Congratulations!",
								message = "You won!!!\n"
								)
					self.__newgame()
				


	def __newgame( self ):
		for x in self.__covers:
			self.__stage.lift( x )
		f = open( 'words.txt', 'r' )
		lst  = f.readlines()
		
		ix = whrandom.randint( 0, len(lst) )
		
		self.__word = lst[ix][:-1]
		

		self.__blankstr =  ""
		for x in range( len( self.__word ) ):
			self.__blankstr = self.__blankstr + "_ "
		self.__blanks["text"] = self.__blankstr

		for x in range( 65, 91 ):
			self.__chrbtns[ chr(x) ]["state"] = NORMAL
			self.__chrbtns[ chr(x) ]["relief"] = "raised"
			self.__chrbtns[ chr(x) ].bind( "<ButtonRelease-1>", self.__btnclick )

		
		self.__trials = -1
		self.__correct = 0
		
		lst = []
		f.close()

	def __drawImages( self ):
		self.__images = { 
				"arm":PhotoImage( file = "arm.gif" ),
				"a0":PhotoImage( file = "a0.gif" ),
				"base":PhotoImage( file = "base.gif" ),
				"blank":PhotoImage( file = "blank.gif" ),
				"a1":PhotoImage( file = "a1.gif" ),
				"c2":PhotoImage( file = "c2.gif" ),
				"b1":PhotoImage( file = "b1.gif" ),
				"b3":PhotoImage( file = "b3.gif" ),
				"d1":PhotoImage( file = "d1.gif" ),
				"d2":PhotoImage( file = "d2.gif" ),
				}
		self.__imgId = []
		self.__covers = []
		self.__stage.create_image( 0, 0, image = self.__images["arm"], anchor = "nw" )
		self.__stage.create_image( 0, 51, image = self.__images["a0"], anchor = "nw" )
		self.__stage.create_image( 0, 253, image = self.__images["base"], anchor = "nw" )

		self.__imgId.append(self.__stage.create_image( 49, 51, image = self.__images["a1"], anchor = "nw" ))
		self.__imgId.append(self.__stage.create_image( 96, 102, image = self.__images["c2"], anchor = "nw" ))
		self.__imgId.append(self.__stage.create_image( 50, 102, image = self.__images["b1"], anchor = "nw" ))
		self.__imgId.append(self.__stage.create_image( 106, 102, image = self.__images["b3"], anchor = "nw" ))
		self.__imgId.append(self.__stage.create_image( 96, 152, image = self.__images["c2"], anchor = "nw" ))
		self.__imgId.append(self.__stage.create_image( 50, 202, image = self.__images["d1"], anchor = "nw" ))
		self.__imgId.append(self.__stage.create_image( 100, 202, image = self.__images["d2"], anchor = "nw" ))
		
		self.__covers.append(self.__stage.create_rectangle( 49, 51, 152, 102, fill = "white", outline = "" ))
		self.__covers.append(self.__stage.create_rectangle( 96, 102, 106, 152, fill = "white", outline = "" ))
		self.__covers.append(self.__stage.create_rectangle( 50, 102, 96, 153, fill = "white", outline = "" ))
		self.__covers.append(self.__stage.create_rectangle( 106, 102, 152, 153, fill = "white", outline = "" ))
		self.__covers.append(self.__stage.create_rectangle( 96, 152, 106, 202, fill = "white", outline = "" ))
		self.__covers.append(self.__stage.create_rectangle( 50, 202, 100, 252, fill = "white", outline = "" ))
		self.__covers.append(self.__stage.create_rectangle( 100, 202, 150, 252, fill = "white", outline = "" ))
		
def run():
	root = Tk()
	frame = Frame( root )
	frame.pack( side = "top", fill = "both" )
	frame2 = Frame( frame )
	frame2.pack( side = "left", fill = "both" )

	app = hangman( frame2 )
	mainloop()